
#include "../../../lib/std.mi"

Global Container NormalContainer;
Global Group NormalLayoutGroup;
Global Layer SplashLayer;
Global Timer SplashTimer, FadeTimer;
Global Int SplashAlpha;

System.onScriptUnloading() {
	delete SplashTimer;
	delete FadeTimer;
	delete SplashLayer;
}

System.onScriptLoaded() {

	NormalContainer = getContainer("main");
	NormalLayoutGroup = NormalContainer.getLayout("normal").getObject("player.normal");
	SplashLayer = NormalLayoutGroup.getObject("splash");
	SplashTimer = new Timer;
	SplashTimer.setDelay(1000);
	SplashTimer.start();
	FadeTimer = new Timer;
	FadeTimer.setDelay(100);
	SplashAlpha = 256;

}

SplashTimer.onTimer() {
	FadeTimer.start();
	SplashTimer.stop();
}

FadeTimer.onTimer() {
	if (SplashAlpha <= 0) {
		FadeTimer.stop();
	}
	else {
		SplashLayer.setAlpha(SplashAlpha);
		SplashAlpha = SplashAlpha - 10;
	}
}