#include "../../../lib/std.mi"

Global AnimatedLayer Dimmer;
Global Timer DimTimer;
Global Float lastFrame;
Global Text Clock;
Global Int Clockcount, DimmerLength;
Global Group ShadeLayoutGroup;

System.onScriptUnloading() {
	delete DimTimer;
}

System.onScriptLoaded() {
    ShadeLayoutGroup = System.getContainer("Main").getLayout("Small").getObject("player.shade");
	Dimmer = ShadeLayoutgroup.getObject("CustomVis");
	Clock = ShadeLayoutgroup.getObject("clock");
	Dimmer.setAlpha(125);
	Dimmer.gotoFrame(0);
	DimmerLength = Dimmer.getLength();
	DimTimer = new Timer;
	DimTimer.setDelay(50);
	DimTimer.start();
	lastFrame = 0;
	Dimmer.hide();
	Clockcount = 0;

}

Dimmer.onLeftButtonUp(int x, int y) {
	if (Dimmer.isVisible()) {
		Dimmer.hide();
		Clock.show();
		Clockcount = 0;
	}
}

Clock.onLeftButtonUp(int x, int y) {
	if (Clock.isVisible()) {
		if (Clockcount == 1) {
			Clock.hide();
			Dimmer.show();
			Clockcount = 0;
		}
		else {
			Clockcount = 1;
		}
	}
}

DimTimer.onTimer() {

	int l, r;
	float v;
	l = System.getLeftVuMeter();
	r = System.getRightVuMeter();

	v = l;
	if (r > v) v = r;
	v = v / 255;

	if (v < lastFrame){
		v = v - (1/1000000);
	}
	else {
		lastFrame = v;
	}

	v = v * (DimmerLength - 1);

	Dimmer.gotoFrame(v);


}