#include "../../../lib/std.mi"

Function setVolumeText(String txt);
Function EmptyTempText();

Global Container MainContainer;
Global Layout NormalLayout, SmallLayout;

Class AnimatedLayer VolumeAnimatedLayer;
Class Slider VolumeHiddenSlider;

Global VolumeAnimatedLayer AnimNorm, AnimSmall;
Global VolumeHiddenSlider SliderNorm, SliderSmall;
Global Int VolumeDrag;

Global Map VolumeMap;
Global Text SongTicker;
Global Timer SongTickerTimer;
Global Group NormalLayoutGroup, SmallLayoutGroup;

System.onScriptUnloading() {
	delete SongTickerTimer;
}

System.onScriptLoaded() {
  MainContainer = System.getContainer("Main");
  NormalLayout = MainContainer.getLayout("Normal");
  NormalLayoutGroup = NormalLayout.getObject("player.normal");
  SmallLayout = MainContainer.getLayout("Small");
  SmallLayoutGroup = SmallLayout.getObject("player.shade");

  AnimNorm = NormalLayoutGroup.getObject("Volume");
  SliderNorm = NormalLayoutGroup.getObject("VolumeSlider");

  AnimSmall = SmallLayoutGroup.getObject("Volume");
  SliderSmall = SmallLayoutGroup.getObject("VolumeSlider");

  SongTicker = NormalLayoutGroup.getObject("Songticker");

  VolumeMap = new Map;
  VolumeMap.loadmap("player.volume-map");

  //Set Volume OnLoad
  float initVolPos = System.getVolume();
  initVolPos = initVolPos / 255 * 52;
  AnimNorm.gotoFrame(52 - initVolPos);
  AnimSmall.gotoFrame(52 - initVolPos);

  SongTickerTimer = new Timer;
  SongTickerTimer.setDelay(1000);
}

VolumeAnimatedLayer.onLeftButtonDown(int x, int y) {
  VolumeDrag = 1;
}

VolumeAnimatedLayer.onMouseMove(int x, int y) {
  If (VolumeDrag) {
    x = x - VolumeAnimatedLayer.getLeft();
    y = y - VolumeAnimatedLayer.getTop();
    If(VolumeMap.inRegion(x,y)) {
      float f = VolumeMap.getValue(x,y);
      f = f - 22;
	f = f / 217;
	System.setVolume(f * 255);
      setVolumeText("Volume: " + System.integerToString(f * 100) + "%");
	f = 1 - f;
      AnimNorm.gotoFrame(f * 52);
      AnimSmall.gotoFrame(f * 52);
    }
  }
}

VolumeAnimatedLayer.onLeftButtonUp(int x, int y) {
  if (VolumeDrag) {
    VolumeDrag = 0;
    x = x - VolumeAnimatedLayer.getLeft();
    y = y - VolumeAnimatedLayer.getTop();
    If(volumeMap.inRegion(x, y)) {
      float f = VolumeMap.getValue(x,y);
      f = f - 22;
	f = f / 217;
	System.setVolume(f * 255);
      setVolumeText("Volume: " + System.integerToString(f * 100) + "%");
	f = 1 - f;
      AnimNorm.gotoFrame(f * 52);
      AnimSmall.gotoFrame(f * 52);
    }
  }
  emptyTempText();
}

VolumeHiddenSlider.onSetPosition(int p) {
	float f = p / 255;
	setVolumeText("Volume: " + System.integerToString(f * 100) + "%");
	f = 1 - f;
	AnimNorm.gotoFrame(f * 52);
	AnimSmall.gotoFrame(f * 52);
}

VolumeHiddenSlider.onSetFinalPosition(int p) {
	float f = p / 255;
	setVolumeText("Volume: " + System.integerToString(f * 100) + "%");
	f = 1 - f;
	AnimNorm.gotoFrame(f * 52);
	AnimSmall.gotoFrame(f * 52);
}

VolumeHiddenSlider.onPostedPosition(int p) {
	float f = p / 255;
	setVolumeText("Volume: " + System.integerToString(f * 100) + "%");
	f = 1 - f;
	AnimNorm.gotoFrame(f * 52);
	AnimSmall.gotoFrame(f * 52);
}

setVolumeText(String txt) {
  Songtickertimer.stop();
  Songticker.setText(txt);
  Songtickertimer.start();
}

Songticker.onNotify(String s1, String s2, int i1, int i2) {
  setVolumeText(s1);
}

Songtickertimer.onTimer() {
  emptyTempText();
}

emptyTempText() {
  Songticker.setText("");
  Songtickertimer.stop();
}